#ifndef _sim68k_clockh_
#define _sim68k_clockh_
#include "device.h"

/** */
class Clock : public Device {
	private:
		/** */
		long						cyclesPerClock;
		/** */
		long						timeRemaining;
		/** */
		long						lastCycle;
		/** */
		bool						interruptEnabled;
		/** */
		static const unsigned long	controlRegOffset = 0;
	public:
		/** */
		Clock(long cpc,int vector,int level,unsigned long baseAddress);
		/** */
		virtual void	reset();
		/** */
		virtual void	poll(unsigned long cyclesSinceLastPoll);
		/** */
		virtual bool	hasAddress(unsigned long address);
		/** */
		virtual bool	hasReadAddress(unsigned long address);
		/** */
		virtual bool	hasWriteAddress(unsigned long address);
		/** */
		virtual bool	hasByteAddress(unsigned long address);
		/** */
		virtual bool	hasWordAddress(unsigned long address);
		/** */
		virtual bool	hasLongAddress(unsigned long address);
		/** */
		virtual unsigned char readByte(unsigned long address);
		/** */
		virtual unsigned short readWord(unsigned long address);
		/** */
		virtual unsigned long readLong(unsigned long address);
		/** */
		virtual void writeByte(unsigned long address,unsigned char data);
		/** */
		virtual void writeWord(unsigned long address,unsigned short data);
		/** */
		virtual void writeLong(unsigned long address,unsigned long data);
		/** */
		virtual void open();
		/** */
		virtual void close();
	};

#endif
