#include "m2681sim.h"

using namespace Oscl;

unsigned char	M2681Loc00::readByte(){
	return _ser._rwShadow.mcr.h;
	}

void	M2681Loc00::writeByte(unsigned char data){
	_ser._rwShadow.mcr.h	= data;
	}

unsigned char	M2681Loc01::readByte(){
	return _ser._rwShadow.mcr.l;
	}

void	M2681Loc01::writeByte(unsigned char data){
	_ser._rwShadow.mcr.l	= data;
	}

unsigned char	M2681Loc02::readByte(){
	return 0x00;	// Do Not Access
	}

void	M2681Loc02::writeByte(unsigned char data){
	// Do Not Access
	}

unsigned char	M2681Loc03::readByte(){
	return 0x00;	// Do Not Access
	}

void	M2681Loc03::writeByte(unsigned char data){
	// Do Not Access
	}

unsigned char	M2681Loc04::readByte(){
	return _ser._rwShadow.ilr;
	}

void	M2681Loc04::writeByte(unsigned char data){
	_ser._rwShadow.ilr	= data;
	}

unsigned char	M2681Loc05::readByte(){
	return _ser._rwShadow.ivr;
	}

void	M2681Loc05::writeByte(unsigned char data){
	_ser._rwShadow.ivr	= data;
	}

unsigned char	M2681Loc10::readByte(){
	return _ser._rwShadow.mr1a;
	}

void	M2681Loc10::writeByte(unsigned char data){
	_ser._rwShadow.mr1a	= data;
	}

unsigned char	M2681Loc11::readByte(){
	return _ser._readShadow.sra;
	}

void	M2681Loc11::writeByte(unsigned char data){
	_ser._writeShadow.csra	= data;
	}

unsigned char	M2681Loc12::readByte(){
	return 0x00;	// Do Not Access
	}

void	M2681Loc12::writeByte(unsigned char data){
	// CRA command write
	unsigned	misc	= data & m2681CrMiscMask;
	unsigned	txcmd	= data & m2681CrTcMask;
	unsigned	rxcmd	= data & m2681CrRcMask;

	switch(misc){
		case m2681CrMiscResetReceiver:
			_ser.resetReceiverA();
			break;
		case m2681CrMiscResetTransmitter:
			_ser.resetTransmitterA();
			break;
		case m2681CrMiscResetErrorStatus:
			_ser.resetErrorStatusA();
			break;
		case m2681CrMiscResetBreakChange:
			_ser.resetBreakChangeInterruptA();
			break;
		case m2681CrMiscStartBreak:
			_ser.startBreakA();
			break;
		case m2681CrMiscStopBreak:
			_ser.stopBreakA();
			break;
		case m2681CrMiscAssertRts:
			_ser.assertRtsA();
			break;
		case m2681CrMiscNegateRts:
			_ser.negateRtsA();
			break;
		}

	switch(txcmd){
		case m2681CrTcEnableTransmitter:
			_ser.transmitterEnableA();
			break;
		case m2681CrTcDisableTransmitter:
			_ser.transmitterDisableA();
			break;
		}

	switch(rxcmd){
		case m2681CrRcEnableReceiver:
			_ser.receiverEnableA();
			break;
		case m2681CrRcDisableReceiver:
			_ser.receiverDisableA();
			break;
		}
	}

unsigned char	M2681Loc13::readByte(){
	return _ser.readRxOctetA();
	}

void	M2681Loc13::writeByte(unsigned char data){
	_ser.writeTxOctetA((Oscl::Octet) data);
	}

unsigned char	M2681Loc14::readByte(){
	return _ser._readShadow.ipcr;
	}

void	M2681Loc14::writeByte(unsigned char data){
	_ser._writeShadow.acr	= data;
	}

unsigned char	M2681Loc15::readByte(){
	return _ser._readShadow.isr;
	}

void	M2681Loc15::writeByte(unsigned char data){
	_ser._writeShadow.ier	= data;
	}

unsigned char	M2681Loc16::readByte(){
	return 0x00;	// Do Not Access
	}

void	M2681Loc16::writeByte(unsigned char data){
	// Do Not Access
	}

unsigned char	M2681Loc17::readByte(){
	return 0x00;	// Do Not Access
	}

void	M2681Loc17::writeByte(unsigned char data){
	// Do Not Access
	}

unsigned char	M2681Loc18::readByte(){
	return _ser._rwShadow.mr1b;
	}

void	M2681Loc18::writeByte(unsigned char data){
	_ser._rwShadow.mr1b	= data;
	}

unsigned char	M2681Loc19::readByte(){
	return _ser._readShadow.srb;
	}

void	M2681Loc19::writeByte(unsigned char data){
	_ser._writeShadow.csrb	= data;
	}

unsigned char	M2681Loc1A::readByte(){
	return 0x00;	// Do Not Access
	}

void	M2681Loc1A::writeByte(unsigned char data){
	// CRB command write
	unsigned	misc	= data & m2681CrMiscMask;
	unsigned	txcmd	= data & m2681CrTcMask;
	unsigned	rxcmd	= data & m2681CrRcMask;

	switch(misc){
		case m2681CrMiscResetReceiver:
			_ser.resetReceiverB();
			break;
		case m2681CrMiscResetTransmitter:
			_ser.resetTransmitterB();
			break;
		case m2681CrMiscResetErrorStatus:
			_ser.resetErrorStatusB();
			break;
		case m2681CrMiscResetBreakChange:
			_ser.resetBreakChangeInterruptB();
			break;
		case m2681CrMiscStartBreak:
			_ser.startBreakB();
			break;
		case m2681CrMiscStopBreak:
			_ser.stopBreakB();
			break;
		case m2681CrMiscAssertRts:
			_ser.assertRtsB();
			break;
		case m2681CrMiscNegateRts:
			_ser.negateRtsB();
			break;
		}

	switch(txcmd){
		case m2681CrTcEnableTransmitter:
			_ser.transmitterEnableB();
			break;
		case m2681CrTcDisableTransmitter:
			_ser.transmitterDisableB();
			break;
		}

	switch(rxcmd){
		case m2681CrRcEnableReceiver:
			_ser.receiverEnableB();
			break;
		case m2681CrRcDisableReceiver:
			_ser.receiverDisableB();
			break;
		}
	}

unsigned char	M2681Loc1B::readByte(){
	return _ser.readRxOctetB();
	}

void	M2681Loc1B::writeByte(unsigned char data){
	_ser.writeTxOctetB((Oscl::Octet) data);
	}

unsigned char	M2681Loc1C::readByte(){
	return 0x00;	// Do Not Access
	}

void	M2681Loc1C::writeByte(unsigned char data){
	// Do Not Access
	}

unsigned char	M2681Loc1D::readByte(){
	return _ser._readShadow.ip;
	}

void	M2681Loc1D::writeByte(unsigned char data){
	_ser._writeShadow.opcr	= data;
	}

unsigned char	M2681Loc1E::readByte(){
	return 0x00;	// Do Not Access
	}

void	M2681Loc1E::writeByte(unsigned char data){
	_ser._writeShadow.set	= data;
	}

unsigned char	M2681Loc1F::readByte(){
	return 0x00;	// Do Not Access
	}

void	M2681Loc1F::writeByte(unsigned char data){
	_ser._writeShadow.clear	= data;
	}

unsigned char	M2681Loc20::readByte(){
	return _ser._rwShadow.mr2a;
	}

void	M2681Loc20::writeByte(unsigned char data){
	_ser._rwShadow.mr2a	= data;
	}

unsigned char	M2681Loc21::readByte(){
	return _ser._rwShadow.mr2b;
	}

void	M2681Loc21::writeByte(unsigned char data){
	_ser._rwShadow.mr2b	= data;
	}

