#include "sab8252xsim.h"
#include "interrupt.h"

using namespace Oscl;

Sab8252xSim::Sab8252xSim(Sab8252xDevice& device):
		_device(device),
		_rx(*this),
		_tx(*this,&_rx),	// Setup for echo
		_channelAInterruptPending(false),
		_channelAExtendedInterruptPending(false),
		_location00(*this),
		_location01(*this),
		_location02(*this),
		_location03(*this),
		_location04(*this),
		_location05(*this),
		_location06(*this),
		_location07(*this),
		_location08(*this),
		_location09(*this),
		_location0A(*this),
		_location0B(*this),
		_location0C(*this),
		_location0D(*this),
		_location0E(*this),
		_location0F(*this),
		_location10(*this),
		_location11(*this),
		_location12(*this),
		_location13(*this),
		_location14(*this),
		_location15(*this),
		_location16(*this),
		_location17(*this),
		_location18(*this),
		_location19(*this),
		_location1A(*this),
		_location1B(*this),
		_location1C(*this),
		_location1D(*this),
		_location1E(*this),
		_location1F(*this),
		_location20(*this),
		_location21(*this),
		_location22(*this),
		_location23(*this),
		_location24(*this),
		_location25(*this),
		_location26(*this),
		_location27(*this),
		_location28(*this),
		_location29(*this),
		_location2A(*this),
		_location2B(*this),
		_location2C(*this),
		_location2D(*this),
		_location2E(*this),
		_location2F(*this),
		_location30(*this),
		_location31(*this),
		_location32(*this),
		_location33(*this),
		_location34(*this),
		_location35(*this),
		_location36(*this),
		_location37(*this),
		_location38(*this),
		_location39(*this),
		_location3A(*this),
		_location3B(*this),
		_location3C(*this),
		_location3D(*this),
		_location3E(*this),
		_location3F(*this)
		{
	}

void Sab8252xSim::reset(){
	unsigned char*	p;
	p					= (unsigned char*)&_readShadow.ISTA;
	*p					= 0;
	_writeShadow.MASK	= 0;	// all enabled
	p					= (unsigned char*)&_readShadow.EXIR;
	*p					= 0;
	p					= (unsigned char*)&_readShadow.STAR;
	*p					= 0x48;
	_writeShadow.CMDR	= 0;	// according to the manual
	_rwShadow.MODE		= 0;
	_rwShadow.TIMR		= 0;	// not specified in the manual
	_writeShadow.XAD1	= 0;	// not specified in the manual
	_writeShadow.XAD2	= 0;	// not specified in the manual
	p					= (unsigned char*)&_readShadow.RBCL;
	*p					= 0;	// not specified in the manual
	_writeShadow.RAH1	= 0;	// not specified in the manual
	_writeShadow.RAH2	= 0;	// not specified in the manual
	p					= (unsigned char*)&_readShadow.RSTA;
	*p					= 0;	// not specified in the manual
	_rwShadow.RAL1		= 0;	// not specified in the manual
	_writeShadow.RAL2	= 0;	// not specified in the manual
	p					= (unsigned char*)&_readShadow.RHCR;
	*p					= 0;	// not specified in the manual
	_writeShadow.XBCL	= 0;	// not specified in the manual
	_writeShadow.BGR	= 0;	// not specified in the manual
	_rwShadow.CCR2		= 0;
	_writeShadow.XBCH	= 0;	// 000XXXXX
	p					= (unsigned char*)&_readShadow.RBCH;
	*p					= 0;	// 000XXXXX
	p					= (unsigned char*)&_readShadow.VSTR;
	*p					= 0x02;	// version number of chip
	_writeShadow.RLCR	= 0;	// not specified in the manual
	_writeShadow.TSAX	= 0;	// not specified in the manual
	_writeShadow.TSAR	= 0;	// not specified in the manual
	_writeShadow.XCCR	= 0;
	_writeShadow.RCCR	= 0;
	_ISTA				= 0;
	_EXIR				= 0;
	_tx.reset();
	_rx.reset();
	updateAll();
	}

void Sab8252xSim::poll(unsigned long clocksThisPoll){
	if(clocksThisPoll){
		_tx.clock(clocksThisPoll);
		_rx.clock(clocksThisPoll);
		}
//	updateAll();
	if(_commandTimer){
		_commandTimer -= clocksThisPoll;
		if (_commandTimer <= 0){
			unsigned char*		star	= (unsigned char *)&_readShadow.STAR;
			_commandTimer = 0;
			*star	&= ~STAR_CEC;
			}
		}
	}

unsigned char Sab8252xSim::readByte(unsigned long offset){
	Sab8252xLoc& loc	= location(offset);
	return loc.readByte();
	}

void Sab8252xSim::writeByte(unsigned long offset,unsigned char data){
	Sab8252xLoc& loc	= location(offset);
	loc.writeByte(data);
	}

Sab8252xLoc& Sab8252xSim::location(unsigned long offset){
	switch(offset){
		case 0x00:
			return _location00;
		case 0x01:
			return _location01;
		case 0x02:
			return _location02;
		case 0x03:
			return _location03;
		case 0x04:
			return _location04;
		case 0x05:
			return _location05;
		case 0x06:
			return _location06;
		case 0x07:
			return _location07;
		case 0x08:
			return _location08;
		case 0x09:
			return _location09;
		case 0x0A:
			return _location0A;
		case 0x0B:
			return _location0B;
		case 0x0C:
			return _location0C;
		case 0x0D:
			return _location0D;
		case 0x0E:
			return _location0E;
		case 0x0F:
			return _location0F;
		case 0x10:
			return _location10;
		case 0x11:
			return _location11;
		case 0x12:
			return _location12;
		case 0x13:
			return _location13;
		case 0x14:
			return _location14;
		case 0x15:
			return _location15;
		case 0x16:
			return _location16;
		case 0x17:
			return _location17;
		case 0x18:
			return _location18;
		case 0x19:
			return _location19;
		case 0x1A:
			return _location1A;
		case 0x1B:
			return _location1B;
		case 0x1C:
			return _location1C;
		case 0x1D:
			return _location1D;
		case 0x1E:
			return _location1E;
		case 0x1F:
			return _location1F;
		case 0x20:
			return _location20;
		case 0x21:
			return _location21;
		case 0x22:
			return _location22;
		case 0x23:
			return _location23;
		case 0x24:
			return _location24;
		case 0x25:
			return _location25;
		case 0x26:
			return _location26;
		case 0x27:
			return _location27;
		case 0x28:
			return _location28;
		case 0x29:
			return _location29;
		case 0x2A:
			return _location2A;
		case 0x2B:
			return _location2B;
		case 0x2C:
			return _location2C;
		case 0x2D:
			return _location2D;
		case 0x2E:
			return _location2E;
		case 0x2F:
			return _location2F;
		case 0x30:
			return _location30;
		case 0x31:
			return _location31;
		case 0x32:
			return _location32;
		case 0x33:
			return _location33;
		case 0x34:
			return _location34;
		case 0x35:
			return _location35;
		case 0x36:
			return _location36;
		case 0x37:
			return _location37;
		case 0x38:
			return _location38;
		case 0x39:
			return _location39;
		case 0x3A:
			return _location3A;
		case 0x3B:
			return _location3B;
		case 0x3C:
			return _location3C;
		case 0x3D:
			return _location3D;
		case 0x3E:
			return _location3E;
		case 0x3F:
			return _location3F;
		default:
			return _location3F;	// well....
		};
	}

void Sab8252xSim::hscxReceiveMessageComplete(){
	_rx.releaseFifo();
	}

void Sab8252xSim::hscxResetHdlcReceiver(){
	_rx.reset();
	}

void Sab8252xSim::hscxReceiverNotReady(){
	}

void Sab8252xSim::hscxTransmissionRepeat(){
	}

void Sab8252xSim::hscxStartTimer(){
	}

void Sab8252xSim::hscxTransmitTransparentFrame(){
	// XTF
	_tx.transmitContentsOfFifo();
	}

void Sab8252xSim::hscxTransmitIFrame(){
	}

void Sab8252xSim::hscxTransmitMessageEnd(){
	// XME
	_tx.endOfFrame();
	}

void Sab8252xSim::hscxTransmitReset(){
	_tx.reset();
	}

unsigned char Sab8252xSim::hscxReadISTA(){
	unsigned char	save = _readShadow.ISTA;

	if(_device.oppositeChannelInterruptPending()){
		 if(_writeShadow.MASK & (1<<ISTA_ICA)){
			save	|= (1<<ISTA_ICA);
			}
		}

	_ISTA	&= ~(save);

	if(_device.oppositeChannelRawExtendedInterruptPending()){
		save	|= (1<<ISTA_EXB);
		}

	if(_device.thisChannelRawExtendedInterruptPending()){
		save	|= (1<<ISTA_EXA);
		}

	updateChipInterrupt();

	return save;
	}

unsigned char	Sab8252xSim::hscxReadEXIR(){
	unsigned char	save = _readShadow.EXIR;
	_EXIR	&= (~save);
	updateChipInterrupt();
	return save;
	}

void	Sab8252xSim::hscxWriteMask(unsigned char mask){
	_writeShadow.MASK	= mask;
	updateChipInterrupt();
	}

void Sab8252xSim::writeTxOctet(Octet data){
	_tx.writeByte(data);
	}

unsigned char Sab8252xSim::readRxOctet(unsigned int index){
	return _rx.readByte(index);
	}

unsigned char	Sab8252xSim::getRBCH(){
	unsigned lenHigh	= _rx.getLength();
	return (unsigned char)(lenHigh>>8);
	}

unsigned char	Sab8252xSim::getRBCL(){
	unsigned lenLow	= _rx.getLength();
	return (unsigned char)lenLow;
	}

void Sab8252xSim::startCommand(){
	unsigned char*		star	= (unsigned char *)&_readShadow.STAR;
	_commandTimer		= _commandPauseTicks;
	*star	|= STAR_CEC;
	}

void Sab8252xSim::receiveMessageComplete(void){
	_ISTA	|= (1<<ISTA_RME);
	updateChipInterrupt();
	}

void Sab8252xSim::receiveFifoFull(void){
	_ISTA	|= (1<<ISTA_RPF);
	updateChipInterrupt();
	}

void Sab8252xSim::updateAll(){
	updateChipInterrupt();
	}

void Sab8252xSim::updateChipInterrupt(){
	Fields*	exir	= (Fields *)&_readShadow.EXIR;
	*exir			= _EXIR;
	updateISTA();
	_device.updateChipInterrupt();
	}

bool	Sab8252xSim::channelInterruptIsPending(){
	return _readShadow.ISTA;
	}

bool	Sab8252xSim::extendedInterruptIsPending(){
	return _readShadow.EXIR;
	}

bool	Sab8252xSim::rawExtendedInterruptIsPending(){
	return _EXIR;
	}

bool	Sab8252xSim::extendedInterruptIsMasked(){
	return _writeShadow.MASK & (1<<ISTA_EXB);
	}

void	Sab8252xSim::oppositeChannelInterruptStatusChanged(){
	updateAll();
	}

void Sab8252xSim::updateISTA(){
	Fields*	ista = (Fields *)&_readShadow.ISTA;
	updateIstaRME();
	updateIstaRPF();
	updateIstaRSC();
	updateIstaXPR();
	updateIstaTIN();
	updateIstaICA();
	updateIstaEXA();
	updateIstaEXB();
	*ista	= _ISTA & (~_writeShadow.MASK);
	}

void Sab8252xSim::updateIstaRME(void){
	}

void Sab8252xSim::updateIstaRPF(void){
	}

void Sab8252xSim::updateIstaRSC(void){
	}

void Sab8252xSim::updateIstaXPR(void){
	}

void Sab8252xSim::updateIstaTIN(void){
	}

void Sab8252xSim::updateIstaICA(void){
	if(_device.oppositeChannelInterruptPending()){
		_ISTA	|= (1<<ISTA_ICA);
		}
	}

void Sab8252xSim::updateIstaEXA(void){
	/*
	if(_device.thisChannelRawExtendedInterruptPending){
		_ISTA	|= (1<<ISTA_EXA);
		}
	 */
	}

void Sab8252xSim::updateIstaEXB(void){
	/*
	if(_device.oppositeChannelRawExtendedInterruptPending()){
		_ISTA	|= (1<<ISTA_EXB);
		}
	 */
	}

void Sab8252xSim::transmitFifoEmpty(){
	_ISTA	|= (1<<ISTA_XPR);
	// a transmit FIFO is available
	// generate an interrupt
	}

void	Sab8252xSim::channelAInterruptPending(){
	_channelAInterruptPending	= true;
	updateChipInterrupt();
	}

void	Sab8252xSim::channelAExtendedInterruptPending(){
	_channelAExtendedInterruptPending	= true;
	updateChipInterrupt();
	}

void Sab8252xSim::open(){
	}

void Sab8252xSim::close(){
	}

